vim.g.mapleader = " "

-- basic UI
vim.o.background = 'dark'
vim.o.termguicolors = true -- enable 24 bit colors in TUI
vim.g.syntax = true
vim.wo.number = true
vim.wo.relativenumber = true
vim.o.signcolumn = 'yes'
vim.o.splitright = true
vim.o.splitbelow = true
vim.o.colorcolumn = '80'

-- text
vim.wo.wrap = false
vim.wo.foldenable = false
vim.o.mouse = 'a' -- enable mouse in all modes
vim.o.tabstop = 4 -- Display width of a <Tab>
vim.o.softtabstop = 4 -- How large inserted tabs are
vim.o.expandtab = false -- Insert <Tab> instead of spaces
vim.o.shiftwidth = 4 -- "Number of spaces used for each step of an (auto)indent"
vim.o.scrolloff = 8 -- Start scrolling when 8 away from top/bottom

-- search
vim.o.hlsearch = false
vim.o.incsearch = true -- Incremental highlighting while typing a search query
vim.o.ignorecase = true
vim.o.smartcase = true -- Match case if a capital letter is used

-- temporary file configuration
vim.o.swapfile = false
vim.o.undofile = true
vim.o.dir = '/tmp'

-- Buffers
vim.o.hidden = true -- Allow hidden buffers without saving
